
#include <math.h>
#include "graphictools.h"

void Setup_Video()
{
    vid.initDisplay(@display1, vid.VGA, VGA_BASE_PIN, VGA_VSYNC_PIN, vid.RGBHV, @lineBuffer, LINEBUFSIZE, 0);

    vid.initRegion(@first, vid.RGBI, 480, 0, 0, 0, 8, &frameBuffer[0], 0);
  
    // enable display list
    vid.setDisplayRegions(display1, first);
}

void line( int x0, int y0, int x1, int y1,int color)
{
  int dx =  abs(x1-x0), sx = x0<x1 ? 1 : -1;
  int dy = -abs(y1-y0), sy = y0<y1 ? 1 : -1;
  int err = dx+dy, e2; /* error value e_xy */

  for(;;){  /* loop */
    plot(x0,y0,color);
    if (x0==x1 && y0==y1) break;
    e2 = 2*err;
    if (e2 > dy) { err += dy; x0 += sx; } /* e_xy+e_x > 0 */
    if (e2 < dx) { err += dx; y0 += sy; } /* e_xy+e_y < 0 */
  }
}

// routine to plot a point at screen coordinate (x,y) and color "color"
void plot(int x, int y, int color)
{
    frameBuffer[y*SCRN_WIDTH+x] = color;
}

// clear the screen
void clearscreen (int color)
{
	
    memset(frameBuffer, color , SCRN_WIDTH*SCRN_HEIGHT);	
}

// Function for circle-generation
// using Bresenham's algorithm
void fillCircle(void *screen, int width, int xc, int yc, int r, int colour, int bpp)
{ 
    int x, y, d;
    x = 0;
    y = r;
    d = 3 - 2 * r;
    horizLine(screen, width, xc+x, yc+y, xc-x, yc+y, colour, bpp);
    horizLine(screen, width, xc+x, yc-y, xc-x, yc-y, colour, bpp);
    horizLine(screen, width, xc+y, yc+x, xc-y, yc+x, colour, bpp);
    horizLine(screen, width, xc+y, yc-x, xc-y, yc-x, colour, bpp);
    while (x <= y)
    {
        horizLine(screen, width, xc+x, yc+y, xc-x, yc+y, colour, bpp);
        horizLine(screen, width, xc+x, yc-y, xc-x, yc-y, colour, bpp);
        horizLine(screen, width, xc+y, yc+x, xc-y, yc+x, colour, bpp);
        horizLine(screen, width, xc+y, yc-x, xc-y, yc-x, colour, bpp);
        if (d > 0)
        {
            d = d + 4 * (x - y) + 10;
            y--;
        }
        else
            d = d + 4 * x + 6;
        x++;
    }
}


void horizLine(void *buf, int width, int x1, int y1, int x2,int y2, int c, int bpp)
{ 
    int  len = x1-x2 + 1;
    switch(bpp)
    {
    case 8:
      bytefill(buf + x2+y1*width, c, len);
      break;
    case 16:
      wordfill(buf + 2*(x2+y1*width), c, len);
      break;
    case 32:
      longfill(buf + 4*(x2+y1*width), c, len);
      break;
     default: return; // unhandled for now
   }
}
